

#ifndef _MC8043P_DLL_H_
#define _MC8043P_DLL_H_


#ifdef MC8043P_DLL_EXPORTS
#define MC8043P_DLL_API __declspec(dllexport)
#else
#define MC8043P_DLL_API __declspec(dllimport)
#endif


///////////////////////////////////////////////////////////////////////////
//
//			ʒ`
//
///////////////////////////////////////////////////////////////////////////

//-------------------------------------------
//				R}h`
//-------------------------------------------
// hCu
#define CMD_F_DRV_P				0x20	// {ʃpXhCu
#define CMD_F_DRV_M				0x21	// |ʃpXhCu
#define CMD_C_DRV_P				0x22	// {ApXhCu
#define CMD_C_DRV_M				0x23	// |ApXhCu
#define CMD_START_HOLD			0x24	// hCuJnz[h
#define CMD_START_FREE			0x25	// hCuJnt[^IXe[^XNA
#define CMD_STP_STS_CLR			0x25	// hCuJnt[^IXe[^XNA
#define CMD_STOP_DEC			0x26	// hCu~
#define CMD_STOP_SUDDEN			0x27	// hCu~

// Ԗ
#define CMD_IP_2ST				0x30	// QԃhCu
#define CMD_IP_3ST				0x31	// RԃhCu
#define CMD_IP_CW				0x32	// bv~ʕԃhCu
#define CMD_IP_CCW				0x33	// bbv~ʕԃhCu
#define CMD_IP_2BP				0x34	// Qrbgp^[ԃhCu
#define CMD_IP_3BP				0x35	// Rrbgp^[ԃhCu
#define CMD_BP_ENABLED			0x36	// aoWX^݉
#define CMD_BP_DISABLED			0x37	// aoWX^ݕs
#define CMD_BP_STACK			0x38	// aof[^X^bN
#define CMD_BP_CLR				0x39	// aof[^NA
#define CMD_IP_1STEP			0x3A	// ԃVOXebv
#define CMD_IP_DEC_VALID		0x3B	// L
#define CMD_IP_DEC_INVALID		0x3C	// 
#define CMD_IP_INTRPT_CLR		0x3D	// Ԋ荞݃NA

// ̖̑
#define CMD_HOME_EXEC			0x62	// _os
#define CMD_DEVCTR_CLR			0x63	// ΍JE^NApXo
#define CMD_SYNC_ACTIVE			0x65	// N
#define CMD_NOP					0x0F	// mnoi؂芷pj

//-------------------------------------------
//		ԏIbZ[WAIXe[^X
//-------------------------------------------

// ԏIbZ[W
#define WM_BP_END			(WM_USER + 1)	// aoԏIbZ[W
#define WM_CIP_END			(WM_USER + 2)	// AԏIbZ[W

//***** BPԁ@IXe[^X *****
// 
#define BP_START			0x101		// obNOEhBPԂJn
#define BP_END				0x102		// BPԐI

// ԊJnÕG[
#define BP_CNT_ERR			0x111		// w肳ꂽf[^͈͊O
#define BP_ALREADY_EXEC		0x112		// ɂaoԁA邢͘AԂs
#define BP_THREAD_ERR		0x113		// XbhNłȂ
#define BP_MALLOC_ERR		0x114		// mۂłȂ

// Ԏs̃G[
#define BP_STOP				0x121		// BPԂrŒ~ixf[^̃X^bNԂɍȂꍇj
#define BP_USER_STOP		0x122		// BPԎsɃ[U[f
#define BP_DRIVE_ERR		0x123		// BPԎsɃ{[hŃG[iRR0ɃG[񂪃Zbgꂽj

//***** Aԁ@IXe[^X *****
// 
#define CIP_START			0x201		// obNOEhŘAԂJn
#define CIP_END				0x202		// AԐI

// ԊJnÕG[
#define CIP_CNT_ERR			0x211		// w肳ꂽf[^͈͊O
#define CIP_ALREADY_EXEC	0x212		// ɂaoԁA邢͘AԂs
#define CIP_THREAD_ERR		0x213		// XbhNłȂ
#define CIP_MALLOC_ERR		0x214		// mۂłȂ
#define CIP_CMD_ERR			0x215		// R}hG[i[U[w肵R}hԈĂj

// Ԏs̃G[
#define CIP_STOP			0x221		// AԂrŒ~ixf[^̃ZbgԂɍȂꍇj
#define CIP_USER_STOP		0x222		// AԎsɃ[U[f
#define CIP_DRIVE_ERR		0x223		// AԎsɃ{[hŃG[iRR0ɃG[񂪃Zbgꂽj

//-------------------------------------------
//			ԃf[^̍\
//-------------------------------------------
#pragma pack(push,8)

// Qao
typedef struct _DATA_2BP
{
	USHORT Bp1p;		// BP1Pf[^
	USHORT Bp1m;		// BP1Mf[^
	USHORT Bp2p;		// BP2Pf[^
	USHORT Bp2m;		// BP2Mf[^
} DATA_2BP;

// Rao
typedef struct _DATA_3BP
{
	USHORT Bp1p;		// BP1Pf[^
	USHORT Bp1m;		// BP1Mf[^
	USHORT Bp2p;		// BP2Pf[^
	USHORT Bp2m;		// BP2Mf[^
	USHORT Bp3p;		// BP3Pf[^
	USHORT Bp3m;		// BP3Mf[^
} DATA_3BP;

// QA
typedef struct _DATA_2CIP	
{
	USHORT	Command;	// ߔԍiCMD_IP_2ST, CMD_IP_CW, CMD_IP_CCŴꂩZbgj
	USHORT	Speed;		// xiw肷ꍇ͂P`WOOOAw肵Ȃꍇ͂OZbgj
	long	EndP1;		// I_iPj
	long	EndP2;		// I_iQj
	long	Center1;	// ~ʒS_iPj
	long	Center2;	// ~ʒS_iQj
} DATA_2CIP;			// FPAQ́AWR5Ŏw肷

// RA
typedef struct _DATA_3CIP	
{
	long	EndP1;		// I_iPj
	long	EndP2;		// I_iQj
	long	EndP3;		// I_iRj
	USHORT	Speed;		// xiw肷ꍇ͂P`WOOOAw肵Ȃꍇ͂OZbgj
} DATA_3CIP;			// FPAQAŔAWR5Ŏw肷

#pragma pack(pop)

///////////////////////////////////////////////////////////////////////////
//
//			MC8043PhCoMC8041PVhCop`
//
///////////////////////////////////////////////////////////////////////////

// AhX`
#define MCX314_WR0		0x0000
#define MCX314_WR1		0x0001
#define MCX314_WR2		0x0002
#define MCX314_WR3		0x0003
#define MCX314_WR4		0x0004
#define MCX314_WR5		0x0005
#define MCX314_WR6		0x0006
#define MCX314_WR7		0x0007

#define MCX314_RR0		0x0000
#define MCX314_RR1		0x0001
#define MCX314_RR2		0x0002
#define MCX314_RR3		0x0003
#define MCX314_RR4		0x0004
#define MCX314_RR5		0x0005
#define MCX314_RR6		0x0006
#define MCX314_RR7		0x0007

// `
#define AXIS_ALL		0xF
#define AXIS_X			0x1
#define AXIS_Y			0x2
#define AXIS_Z			0x4
#define AXIS_U			0x8
#define AXIS_NONE		0		// w薳


//------------------------------------------------------------------
//						MC8043PhCo֐
//------------------------------------------------------------------
MC8043P_DLL_API BOOL __stdcall OpenMC8043P(int No);								// MC8043PI[v
MC8043P_DLL_API long __stdcall InpMC8043P(int No, long Adr);					// MC8043P|[g
MC8043P_DLL_API void __stdcall OutpMC8043P(int No, long Adr, long Dat);			// MC8043Pփ|[go
MC8043P_DLL_API BOOL __stdcall SetEventMC8043P(int No, LPTHREAD_START_ROUTINE UserThread, LPVOID lpParameter);
																				// ݃[U[֐̐ݒ(Xbh)
MC8043P_DLL_API BOOL __stdcall ResetEventMC8043P(int No);						// ݃[U[֐̐ݒ
MC8043P_DLL_API BOOL __stdcall CloseMC8043P(int No);							// MC8043PN[Y
MC8043P_DLL_API BOOL __stdcall CloseAllMC8043P(void);							// MC8043PSăN[Y
MC8043P_DLL_API BOOL __stdcall ReadEventMC8043P(int No,
												long* Rr3X,
												long* Rr3Y,
												long* Rr3Z,
												long* Rr3U
												);				// ݔRR3̒lǂݏo(ǏoNA)
MC8043P_DLL_API BOOL __stdcall CheckEventMC8043P(int No,
												long* Rr3X,
												long* Rr3Y,
												long* Rr3Z,
												long* Rr3U
												);				// ݔRR3̒lǂݏo(ǏoNA)


// ߁EZbg
MC8043P_DLL_API void __stdcall Nmc_Reset(int No);							// Zbg
MC8043P_DLL_API void __stdcall Nmc_Command(int No, int axis, int cmd);		// w薽ߏ݁iR}hsj
MC8043P_DLL_API void __stdcall Nmc_Command_IP(int No, int cmd);				// Ԗߏ݁@iR}hsj

// CgWX^
MC8043P_DLL_API void __stdcall Nmc_WriteReg0(int No, long wdata);			// CgWX^Oݒ
MC8043P_DLL_API void __stdcall Nmc_WriteReg1(int No, int axis, long wdata);	// CgWX^Pݒ
MC8043P_DLL_API void __stdcall Nmc_WriteReg2(int No, int axis, long wdata);	// CgWX^Qݒ
MC8043P_DLL_API void __stdcall Nmc_WriteReg3(int No, int axis, long wdata);	// CgWX^Rݒ
MC8043P_DLL_API void __stdcall Nmc_WriteReg4(int No, long wdata);			// CgWX^Sݒ
MC8043P_DLL_API void __stdcall Nmc_WriteReg5(int No, long wdata);			// CgWX^Tݒ
MC8043P_DLL_API void __stdcall Nmc_WriteReg6(int No, long wdata);			// CgWX^Uݒ
MC8043P_DLL_API void __stdcall Nmc_WriteReg7(int No, long wdata);			// CgWX^Vݒ							

// [hWX^
MC8043P_DLL_API long __stdcall Nmc_ReadReg0(int No);						// [hWX^Oǂݏo
MC8043P_DLL_API long __stdcall Nmc_ReadReg1(int No, int axis);				// [hWX^Pǂݏo
MC8043P_DLL_API long __stdcall Nmc_ReadReg2(int No, int axis);				// [hWX^Qǂݏo
MC8043P_DLL_API long __stdcall Nmc_ReadReg4(int No);						// [hWX^Sǂݏo
MC8043P_DLL_API long __stdcall Nmc_ReadReg5(int No);						// [hWX^Tǂݏo
MC8043P_DLL_API long __stdcall Nmc_ReadReg6(int No);						// [hWX^Uǂݏo
MC8043P_DLL_API long __stdcall Nmc_ReadReg7(int No);						// [hWX^Vǂݏo

// p[^ݒ
MC8043P_DLL_API void __stdcall Nmc_Range(int No, int axis, long wdata);		// Wݒ
MC8043P_DLL_API void __stdcall Nmc_Jerk(int No, int axis, long wdata);		// x(K)ݒ
MC8043P_DLL_API void __stdcall Nmc_Acc(int No, int axis, long wdata);		// x(A)ݒ
MC8043P_DLL_API void __stdcall Nmc_Dec(int No, int axis, long wdata);		// x(D)ݒ
MC8043P_DLL_API void __stdcall Nmc_StartSpd(int No, int axis, long wdata);	// x(SV)ݒ
MC8043P_DLL_API void __stdcall Nmc_Speed(int No, int axis, long wdata);		// hCux(V)ݒ
MC8043P_DLL_API void __stdcall Nmc_Pulse(int No, int axis, long wdata);		// o̓pX^ԏI_(P)ݒ (VC)
MC8043P_DLL_API void __stdcall Nmc_DecP(int No, int axis, ULONG wdata);		// }jA_(DP)ݒ (VC)
MC8043P_DLL_API void __stdcall Nmc_Center(int No, int axis, long wdata);	// ~ʒS_(C)ݒ
MC8043P_DLL_API void __stdcall Nmc_Lp(int No, int axis, long wdata);		// _ʒuJE^(LP)ݒ
MC8043P_DLL_API void __stdcall Nmc_Ep(int No, int axis, long wdata);		// ʒuJE^(EP)ݒ
MC8043P_DLL_API void __stdcall Nmc_CompP(int No, int axis, long wdata);		// COMP+(CP)ݒ
MC8043P_DLL_API void __stdcall Nmc_CompM(int No, int axis, long wdata);		// COMP-(CM)ݒ
MC8043P_DLL_API void __stdcall Nmc_AccOfst(int No, int axis, long wdata);	// JE^ItZbg(AO)ݒ
MC8043P_DLL_API void __stdcall Nmc_DJerk(int No, int axis, long wdata);		// x(L)ݒ
MC8043P_DLL_API void __stdcall Nmc_HomeSpd(int No, int axis, long wdata);	// _ox(HV)ݒ

// gE[hݒ
MC8043P_DLL_API void __stdcall Nmc_ExpMode(int No, int axis, long EM6_data, long EM7_data);	// g[h(EM)ݒ
MC8043P_DLL_API void __stdcall Nmc_SyncMode(int No, int axis, long SM6_data, long SM7_data);// 샂[h(SM)ݒ

// f[^ǂݏo
MC8043P_DLL_API long __stdcall Nmc_ReadLp(int No, int axis);				// _ʒuJE^l(LP)ǂݏo 
MC8043P_DLL_API long __stdcall Nmc_ReadEp(int No, int axis);				// ʒuJE^l(EP)ǂݏo
MC8043P_DLL_API long __stdcall Nmc_ReadSpeed(int No, int axis);				// ݃hCux(CV)ǂݏo
MC8043P_DLL_API long __stdcall Nmc_ReadAccDec(int No, int axis);			// ݉^x(CA)ǂݏo
MC8043P_DLL_API long __stdcall Nmc_ReadSyncBuff(int No, int axis);			// obt@WX^(BR)ǂݏo

MC8043P_DLL_API int __stdcall Nmc_GetDriveStatus(int No, int axis);			// hCuԎ擾	0:hCuIA0ȊOFhCu
MC8043P_DLL_API int __stdcall Nmc_GetCNextStatus(int No);					// AԎf[^݉\Ԏ擾	0:f[^ݕsA0ȊOFf[^݉\
MC8043P_DLL_API int __stdcall Nmc_GetBpSc(int No);							// aoԃX^bNJE^擾 0`3

// ݁Eǂݏo
MC8043P_DLL_API void __stdcall Nmc_WriteRegSetAxis(int No, int axis, int RegNumber, long wdata);		// CgWX^݁@ݒ(WR1`3)
MC8043P_DLL_API long __stdcall Nmc_ReadRegSetAxis(int No, int axis, int RegNumber);						// [hWX^ǂݏo@ݒ(RR1`3)
MC8043P_DLL_API void __stdcall Nmc_WriteData(int No, int axis, int cmd, long wdata);					// f[^݁ip[^j
MC8043P_DLL_API void __stdcall Nmc_WriteData2(int No, int axis, int cmd, long WR6_data, long WR7_data);	// f[^݁ig[hA[hj
MC8043P_DLL_API long __stdcall Nmc_ReadData(int No, int axis, int cmd);									// f[^ǂݏo 

// ԁiaoԁ^Aԁj

// QaoԎs
MC8043P_DLL_API DWORD __stdcall Nmc_2BPExec(int No, DATA_2BP* pData2Bp, int DataCnt, int IpAxis, BOOL ContinueFlg = FALSE);
// RaoԎs
MC8043P_DLL_API DWORD __stdcall Nmc_3BPExec(int No, DATA_3BP* pData3Bp, int DataCnt, int IpAxis, BOOL ContinueFlg = FALSE);
// QaoԎsiobNOEhŎsj
MC8043P_DLL_API DWORD __stdcall Nmc_2BPExec_BG(HWND User_hWnd, int No, DATA_2BP* pData2Bp, int DataCnt,
											   int IpAxis, BOOL ContinueFlg = FALSE);
// RaoԎsiobNOEhŎsj
MC8043P_DLL_API DWORD __stdcall Nmc_3BPExec_BG(HWND User_hWnd, int No, DATA_3BP* pData3Bp, int DataCnt,
											   int IpAxis, BOOL ContinueFlg = FALSE);
// QAԎs
MC8043P_DLL_API DWORD __stdcall Nmc_2CIPExec(int No, DATA_2CIP* pData2Cip, int DataCnt,
											 int IpAxis, BOOL SpdChgFlg = FALSE, BOOL ContinueFlg = FALSE);
// RAԎs
MC8043P_DLL_API DWORD __stdcall Nmc_3CIPExec(int No, DATA_3CIP* pData3Cip, int DataCnt,
											 int IpAxis, BOOL SpdChgFlg = FALSE, BOOL ContinueFlg = FALSE);
// QAԎsiobNOEhŎsj
MC8043P_DLL_API DWORD __stdcall Nmc_2CIPExec_BG(HWND User_hWnd, int No, DATA_2CIP* pData2Cip,
												int DataCnt, int IpAxis, BOOL SpdChgFlg = FALSE, BOOL ContinueFlg = FALSE);
// RAԎsiobNOEhŎsj
MC8043P_DLL_API DWORD __stdcall Nmc_3CIPExec_BG(HWND User_hWnd, int No, DATA_3CIP* pData3Cip,
												int DataCnt, int IpAxis, BOOL SpdChgFlg = FALSE, BOOL ContinueFlg = FALSE);
// Ԃ𒆒fiԃhCu𑦒~AL̕Ԋ֐Ŏs̕ԏIj
MC8043P_DLL_API BOOL __stdcall Nmc_IPStop(int No);



//------------------------------------------------------------------
//						MC8041PVhCo֐
//
//	iMC8041PVhCo֐MC8043P.DLLŎgp\ɂׂ̒`j
//------------------------------------------------------------------
MC8043P_DLL_API BOOL __stdcall OpenMC8041P(int No);								// I[v
MC8043P_DLL_API long __stdcall InpMC8041P(int No, long Adr);					// |[g
MC8043P_DLL_API void __stdcall OutpMC8041P(int No, long Adr, long Dat);			// |[go
MC8043P_DLL_API void __stdcall SetEventMC8041P(int No, LPTHREAD_START_ROUTINE UserThread);			
																				// ݃[U[֐̐ݒ(Xbh)
MC8043P_DLL_API void __stdcall ResetEventMC8041P(int No);						// ݃[U[֐̐ݒ
MC8043P_DLL_API BOOL __stdcall CloseMC8041P(int No);							// N[Y
MC8043P_DLL_API void __stdcall CloseAllMC8041P(void);							// SăN[Y
MC8043P_DLL_API void __stdcall ReadEventMC8041P(int No,
												long* Rr3X,
												long* Rr3Y,
												long* Rr3Z,
												long* Rr3U
												);					// ݔRR3̒lǂݏo(ǏoNA)
MC8043P_DLL_API void __stdcall CheckEventMC8041P(int No,
												long* Rr3X,
												long* Rr3Y,
												long* Rr3Z,
												long* Rr3U
												);					// ݔRR3̒lǂݏo(ǏoNA)



///////////////////////////////////////////////////////////////////////////
//
//					MC8041PhCop`
//
//		iMC8041PhCoMC8043P.DLLŎgp\ɂׂ̒`j
//
///////////////////////////////////////////////////////////////////////////

// WX^`
#define WR0		1
#define WR1		2
#define WR2		3
#define WR3		4
#define WR4		5
#define WR5		6
#define WR6		7
#define WR7		8

#define RR0		9
#define RR1		10
#define RR2		11
#define RR3		12
#define RR4		13
#define RR5		14
#define RR6		15
#define RR7		16

//------------------------------------------------------------------
//						MC8041PhCo֐
//
//	iMC8041PhCo֐MC8043P.DLLŎgp\ɂׂ̒`j
//------------------------------------------------------------------
MC8043P_DLL_API HANDLE _stdcall OpenCard( void (WINAPI *isr)(void));			// I[vA݃[U[֐̐ݒ(Xbh)
MC8043P_DLL_API HANDLE _stdcall OpenCard_N( int no, void (WINAPI *isr)(void));	// I[vA݃[U[֐̐ݒ(Xbh)
MC8043P_DLL_API void _stdcall OutW( WORD iocc, int data );						// |[go
MC8043P_DLL_API void _stdcall OutW_N( int no, WORD iocc, int data );			// |[go
MC8043P_DLL_API WORD _stdcall InW( WORD iocc );									// |[g
MC8043P_DLL_API WORD _stdcall InW_N( int no, WORD iocc );						// |[g
MC8043P_DLL_API BOOL _stdcall CloseCard( void );								// N[Y
MC8043P_DLL_API BOOL _stdcall CloseCard_N( int no );							// N[Y
MC8043P_DLL_API BOOL _stdcall CloseCard_all( void );							// SăN[Y
MC8043P_DLL_API void _stdcall ReadRR3(WORD* Rr3X,
									  WORD* Rr3Y,
									  WORD* Rr3Z,
									  WORD* Rr3U
									  );					// ݔRR3̒lǂݏo(ǏoNA)
MC8043P_DLL_API void _stdcall ReadRR3_N( int no,
									  WORD* Rr3X,
									  WORD* Rr3Y,
									  WORD* Rr3Z,
									  WORD* Rr3U
									  );					// ݔRR3̒lǂݏo(ǏoNA)



#endif	// _MC8043P_DLL_H_
