/////////  lbWOSRo@TvvOC@////////
//
//			@w~bg͐Mԕ\
//			Aw{/|ʃhCuƘ_ʒuJE^\
//
//		00/01/15	start by ISHIDA
//		00/03/14	multi board modified by G
//		01/04/25	add limit check by G
//		01/05/02	change SetTimer() & TimerProc func. for VC++6.0 by G

#include <stddef.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include <windows.h>
#include <conio.h>
#include <LIMITS.H>

#include "MC8043P_DLL.H"

#define		Y_SIZE		100
#define		X_SIZE		450
#define		CARD_MAX	10

// O[oϐ
int		BoardOk[CARD_MAX];

HWND	hWndElpx[CARD_MAX];
HWND	hWndIndx[CARD_MAX];
HWND	hWndLmtmx[CARD_MAX];
HWND	hWndLmtpx[CARD_MAX];
HWND	hWndBtnxp[CARD_MAX];
HWND	hWndBtnxm[CARD_MAX];

// MC8043PI[v
void MC8043P_OpenAll(void)
{
	BOOL	Status;
	int		no;

	for(no = 0; no < CARD_MAX; no++)
	{
		BoardOk[ no ] = 1;

		Status = OpenMC8043P(no);	// MC8043P{[hI[v

		if(Status == FALSE)
		{
			// I[vG[
			BoardOk[ no ]= 0;
		}
		else 
		{
			// lbwRPS̏ݒ
			Nmc_Reset(no);							// Zbg

			Nmc_WriteReg1(no, AXIS_ALL, 0x0000);	// [hWX^P
			Nmc_WriteReg2(no, AXIS_ALL, 0x2000);	// [hWX^Q ALARML
			Nmc_WriteReg3(no, AXIS_ALL, 0x0000);	// [hWX^R
			Nmc_WriteReg4(no, 0x0000);				// AEgvbgWX^@SOUT0`3F0
			Nmc_WriteReg5(no, 0x0000);				// ԃ[hWX^FԐݒȂ

			//------ S p[^ݒ --
			Nmc_AccOfst(no, AXIS_ALL, 0);			// AO = 0
			Nmc_Range(no, AXIS_ALL, 800000);		// R = 800000i{ = 10)
			Nmc_Jerk(no, AXIS_ALL, 1010);			// K = 1010   (x = 619KPPS/SEC2)
			Nmc_Acc(no, AXIS_ALL, 100);				// A = 100    (/x = 125KPPS/SEC)
			Nmc_Dec(no, AXIS_ALL, 100);				// D = 100    (x = 125KPPS/SEC)
			Nmc_StartSpd(no, AXIS_ALL, 100);		// SV= 100    (x = 1000PPS)
			Nmc_Speed(no, AXIS_ALL, 1000);			// V = 1000   (hCux = 10000PPS)
			Nmc_Pulse(no, AXIS_ALL, 10000);			// P = 10000  (o̓pX = 10000)
			Nmc_CompP(no, AXIS_ALL, 0);				// CP = 0    iCOMP+WX^ = 0j
			Nmc_CompM(no, AXIS_ALL, 0);				// CM = 0    iCOMP-WX^ = 0j
			Nmc_Lp(no, AXIS_ALL, 0);				// LP= 0      (_ʒuJE^ = 0)
			Nmc_Ep(no, AXIS_ALL, 0);				// EP= 0      (ʒuJE^ = 0)
		}
	}
}

// 20msec^C}[Fw~bg͐Mԕ\Aw_ʒuJE^\
//int __stdcall TimerJob( void )		// VC6 Ή ɕύX by G 2001/05/02
void CALLBACK TimerJob( HWND hwnd, UINT nMsg, UINT idEvent, DWORD dwTime )
{
	long	indata;
	int		no;
	long	lpv;
	TCHAR	sBuff[128];


	for(no = 0; no < CARD_MAX; no++)
	{
		if(BoardOk[ no ])
		{
			// w~bg͐Mԕ\
			indata = Nmc_ReadReg2(no, AXIS_X);	// wqqQWX^ǂݏo

			if(indata & 0x0004)		SetWindowText(hWndLmtpx[ no ],"ON ");
			else					SetWindowText(hWndLmtpx[ no ],"OFF");

			UpdateWindow(hWndLmtpx[ no ]);

			if(indata & 0x0008)		SetWindowText(hWndLmtmx[ no ],"ON ");
			else					SetWindowText(hWndLmtmx[ no ],"OFF");

			UpdateWindow(hWndLmtmx[ no ]);

			// w_ʒuJE^\
			lpv = Nmc_ReadLp(no, AXIS_X);			// w_ʒuJE^ǂݏo
			wsprintf( sBuff, "%d", lpv );
			SetWindowText( hWndElpx[ no ], sBuff );
			UpdateWindow( hWndElpx[ no ]);
		}
	}

	return/*( 0 )*/;			// VC6 Ή ɕύX by G 2001/05/02
}

///////////////////////////////////////////////////////////////

// qEChE̔Fihcԍj̐錾

int		ELPX[CARD_MAX];
int		INDEX[CARD_MAX];
int		LMTMX[CARD_MAX];
int		LMTPX[CARD_MAX];
int		BTNXP[CARD_MAX];
int		BTNXM[CARD_MAX];


// ֐̃vg^Cv錾
LRESULT CALLBACK WndProc(HWND, UINT, WPARAM, LPARAM);

// Gg|Cg@@@@//////////////////////////////////////////
int APIENTRY WinMain(HINSTANCE hInstance,
                        HINSTANCE hPrevInstance,
                        LPSTR lpCmdLine,
                        int nCmdShow )
{
	WNDCLASSEX wcex;	// EChENX\
	HWND hWnd;			// EChEnh
	MSG msg;			// bZ[W\
	int i;

	// qEChE̔Fihcԍj̏
	for( i = 0; i < CARD_MAX; i++ ){
		ELPX[i] = 100+i;
		INDEX[i] = 110+i;
		LMTMX[i] = 120+i;
		LMTPX[i] = 130+i;
		BTNXP[i] = 140+i;
		BTNXM[i] = 150+i;
	}

	// EBhENX\̂ݒ肵܂B
	wcex.cbSize = sizeof(WNDCLASSEX);
	wcex.style = CS_HREDRAW | CS_VREDRAW;
	wcex.lpfnWndProc = (WNDPROC)WndProc;
	wcex.cbClsExtra = 0;
	wcex.cbWndExtra = 0;
	wcex.hInstance = hInstance;
	wcex.hIcon = LoadIcon(NULL, IDI_APPLICATION);
	wcex.hCursor = LoadCursor(NULL, IDC_ARROW);
	wcex.hbrBackground = (HBRUSH)(COLOR_WINDOW + 1);
	wcex.lpszMenuName = NULL;
	wcex.lpszClassName = "ModelApp";
	wcex.hIconSm = LoadIcon(NULL, IDI_APPLICATION);

	// {[hI[v
	MC8043P_OpenAll();					

	// EChENXo^܂B
	RegisterClassEx(&wcex);

	// EChE쐬܂B
   	hWnd = CreateWindow(wcex.lpszClassName,		// EChENX
		"lbWOSRo  TvvOb", // LvV
		WS_OVERLAPPEDWINDOW,					// EChẼX^C
		CW_USEDEFAULT,							// ʒu
		CW_USEDEFAULT,							// ʒu
		910,									// 
		530,									// 
		NULL,									// eEChE
		NULL,									// EChEj[
		hInstance,								// CX^Xnh
		NULL);									// WM_CREATE

	// EChE\܂B
	ShowWindow(hWnd, nCmdShow);
	UpdateWindow(hWnd);


	SetTimer(hWnd, 1, 20, TimerJob);	// ͐Mԕ\p20msec^C}[Jn

	// bZ[W[v
	while(GetMessage(&msg, NULL, 0, 0))
	{
		TranslateMessage(&msg);
		DispatchMessage(&msg);
	}

	KillTimer(hWnd, 1);		// ͐Mԕ\p^C}[~
	CloseAllMC8043P();		// MC8043PS{[hN[Y


	// ߂lԂ܂B
	return msg.wParam;
}

// EChEvV[W
LRESULT CALLBACK WndProc(HWND hWnd,
                               UINT message,
                               WPARAM wParam,
                               LPARAM lParam)
{
	double	pulse;
	int		no;
	TCHAR	sBuff[128];
	int		ShiftX = 0;
	int		ShiftY = 0;

	// bZ[W̎ނɉď𕪊򂵂܂B
	switch( message ){
		case WM_CREATE:
		// EChE쐬ꂽƂ̏
			for( no = 0; no < CARD_MAX; no++ ){
				if( BoardOk[ no ]){
				// ̕\
					sprintf( sBuff, "No.%d wkls{", no );
					CreateWindow("STATIC",sBuff,
								WS_CHILD | WS_VISIBLE ,
								10+ShiftX, 10+ShiftY, 170, 20,
								hWnd,NULL,NULL,NULL);

					CreateWindow("STATIC","wkls|",
								WS_CHILD | WS_VISIBLE | ES_CENTER,
								230+ShiftX, 10+ShiftY, 170, 20,
								hWnd,NULL,NULL,NULL);

					CreateWindow("STATIC","w_ʒuJE^",
								WS_CHILD | WS_VISIBLE | ES_CENTER,
								10+ShiftX, 40+ShiftY, 170, 20,
								hWnd,NULL,NULL,NULL);

					CreateWindow("STATIC","o̓pX",
								WS_CHILD | WS_VISIBLE | ES_CENTER,
								10+ShiftX, 70+ShiftY, 170, 20,
								hWnd,NULL,NULL,NULL);

				// JE^g̕\
					hWndElpx[ no ]= CreateWindow("EDIT","",
								WS_CHILD | WS_VISIBLE | WS_BORDER | ES_RIGHT,
								190+ShiftX, 40+ShiftY, 180, 25,
								hWnd,(HMENU)ELPX[ no ],
								(HINSTANCE)GetWindowLong(hWnd, GWL_HINSTANCE),
								NULL);

					hWndIndx[ no ]= CreateWindow("EDIT","",
								WS_CHILD | WS_VISIBLE | WS_BORDER | ES_RIGHT,
								190+ShiftX, 70+ShiftY, 180, 25,
								hWnd,(HMENU)INDEX[ no ],
								(HINSTANCE)GetWindowLong(hWnd, GWL_HINSTANCE),
								NULL);

					if( BoardOk[ no ]){
						// o̓pXl:10000
						pulse = 10000;				
						Nmc_Pulse( no, AXIS_X, (unsigned long)pulse );	// pXݒ
						SetWindowText( hWndIndx[ no ], "10000" );
					}

					// w~bg͐MԃEChE̕\
					hWndLmtmx[ no ]= CreateWindow("EDIT","0",
								WS_CHILD | WS_VISIBLE | WS_BORDER | ES_CENTER,
								410+ShiftX, 10+ShiftY, 30, 26,
								hWnd,(HMENU)LMTMX[ no ],
								(HINSTANCE)GetWindowLong(hWnd, GWL_HINSTANCE),
								NULL);

					hWndLmtpx[ no ]= CreateWindow("EDIT","0",
								WS_CHILD | WS_VISIBLE | WS_BORDER | ES_CENTER,
								190+ShiftX, 10+ShiftY, 30, 26,
								hWnd,(HMENU)LMTPX[ no ],
								(HINSTANCE)GetWindowLong(hWnd, GWL_HINSTANCE),
								NULL);

					// {/|@{^̕\
					hWndBtnxp[ no ]= CreateWindow("BUTTON","{",
								WS_CHILD | WS_VISIBLE | BS_PUSHBUTTON,
								375+ShiftX, 40+ShiftY, 30, 55,
								hWnd,(HMENU)BTNXP[ no ],
								(HINSTANCE)GetWindowLong(hWnd, GWL_HINSTANCE),
								NULL);

					hWndBtnxm[ no ]= CreateWindow("BUTTON","|",
								WS_CHILD | WS_VISIBLE | BS_PUSHBUTTON,
								410+ShiftX, 40+ShiftY, 30, 55,
								hWnd,(HMENU)BTNXM[ no ],
								(HINSTANCE)GetWindowLong(hWnd, GWL_HINSTANCE),
								NULL);
				} else {
					// {[hȂ\
					sprintf( sBuff, "No.%d {[h܂I", no );
					CreateWindow("STATIC",sBuff,
								WS_CHILD | WS_VISIBLE ,
								10+ShiftX, 10+ShiftY, 430, 85,
								hWnd,NULL,NULL,NULL);
				}

				if( no == 4 ){
					ShiftX += X_SIZE;
					ShiftY = 0;
				}
				else{
					ShiftY += Y_SIZE;
				}
			}
			return( 0 );

		case WM_COMMAND:
			// {^NbNꂽƂ̏
			for( no = 0; no < CARD_MAX; no++){
				if( BoardOk[ no ]){

					// w{NbN
					if( LOWORD(wParam) == BTNXP[ no ])
					{
						GetWindowText( hWndIndx[ no ], sBuff, 79 );		//o̓pXǂݏo
						pulse = atof( sBuff );

						if(pulse < 0 || pulse > ULONG_MAX)				//o̓pX`FbN 
							MessageBox(hWnd,"o̓pX͈͊OłBo̓pX́A0`4294967295łB","̓G[",MB_OK);
						
						else
						{
							Nmc_Pulse(no, AXIS_X, (unsigned long)pulse);// o̓pXݒ

							Nmc_Command(no, AXIS_X, CMD_F_DRV_P);		//w{ʃhCu
						}
					}

					// w|NbN
					if( LOWORD(wParam) == BTNXM[ no ])
					{
						GetWindowText( hWndIndx[ no ], sBuff, 79 );		//o̓pXǂݏo
						pulse = atof( sBuff );

						if(pulse < 0 || pulse > ULONG_MAX)				//o̓pX`FbN 
							MessageBox(hWnd,"o̓pX͈͊OłBo̓pX́A0`4294967295łB","̓G[",MB_OK);
						
						else
						{
							Nmc_Pulse(no, AXIS_X, (unsigned long)pulse);// o̓pXݒ

							Nmc_Command(no, AXIS_X, CMD_F_DRV_M);		//w|ʃhCu
						}
					}
				}
			}
			return( 0 );

		case WM_DESTROY:
			// EChEjꂽƂ̏
			PostQuitMessage( 0 );
			return( 0 );

		default:
			// ftHg̏
			return( DefWindowProc( hWnd, message, wParam, lParam ));
   	}
}


